#include <iostream>
#include <string>
#include <stdio.h>
#include "list.h"
using namespace std;


/*The generic food class from which all other food items are derived.*/
class Food
{
public:
	char name[15];
	float price;
	int calories;
	Food() {strcpy(name,"");price=0.0;calories=0;}
	Food(char name1[], float cost, int cal) {strcpy(name,name1);price=cost;calories=cal;}
};



/* Appetizer class deriving from Food*/

class Appetizer :public Food
{
	public:
    char ingredients[15];
	Appetizer(){}
	Appetizer(char name1[], float cost, int cal,char ing[]) 
	{
		
		strcpy(name,name1);
		price=cost;
		calories=cal;
		strcpy(ingredients,ing);
		
	}

	void print()
	{
		cout<<endl<<"\nname= "<<name<<"\ningre= "<<ingredients<<"\nprice= "<<price<<"\ncalories= "<<calories;
	}

/* to print on to a stream.file or file*/

void printOn (ostream & o)
  {


    o << name<<'\n'<<ingredients<<'\n'<<price<<'\n'<<calories<<'\n';


  }

/*operator != overloaded to check the equality of 2 node*/
	
  int operator != (Appetizer a)
  {

	if(strcmp(name,a.name)==0) {return 0;}
	else return 1;

  }
};

/*Main dish class deriving from Food*/


class MainDish :public Food
{
	public:
    	char ingredients[15];
	char sideDish[15];
	//constructors
	MainDish(){}
	MainDish(char name1[], float cost, int cal,char ing[],char side[]) 
	{
		
		strcpy(name,name1);
		price=cost;
		calories=cal;
		strcpy(ingredients,ing);
		strcpy(sideDish,side);
	}

	void print()
	{
		cout<<endl<<"\nname= "<<name<<"\ningre= "<<ingredients<<"\nprice= "<<price<<"\ncalories= "<<calories<<"\nsidedish= "<<sideDish;
	}


/* to print on to a stream.file or file*/ 
void printOn (ostream & o)
  {


    o << name<<'\n'<<ingredients<<'\n'<<price<<'\n'<<calories<<'\n'<<sideDish<<'\n';


  }

void getFile(istream & i)
	{
	i>>name>>ingredients>>price>>calories>>sideDish;
	}


/*operator != overloaded to check the equality of 2 node*/
	
  int operator != (MainDish a)
  {

	if(strcmp(name,a.name)==0) {return 0;}
	else return 1;

  }
};

/*dessert class deriving from Food*/
class Dessert :public Food
{
	public:
    	char description[15];
	
	Dessert(){}
	Dessert(char name1[], float cost, int cal,char des[]) 
	{
		
		strcpy(name,name1);
		price=cost;
		calories=cal;
		strcpy(description, des);
		
	}

	void print()
	{
		cout<<endl<<"\nname= "<<name<<"\ndescription= "<<description<<"\nprice= "<<price<<"\ncalories= "<<calories;
	}

 void printOn (ostream & o)
  {


    o << name<<'\n'<<description<<'\n'<<price<<'\n'<<calories<<'\n';


  }


void getFile(istream & i)
	{
	i>>name>>description>>price>>calories;
	}



/*operator != overloaded to check the equality of 2 node*/
  int operator != (Dessert d)
  {

	if(strcmp(name,d.name)==0) {return 0;}
	else return 1;

  }
};

/*LongDrink class deriving from Food*/
class LongDrink :public Food
{
	public:
    char ingredients[15];

	LongDrink(){}
	LongDrink(char name1[], float cost, int cal,char ing[]) 
	{
		
		strcpy(name,name1);
		price=cost;
		calories=cal;
		strcpy(ingredients,ing);
		
	}

	void print()
	{
		cout<<endl<<"\nname= "<<name<<"\ningre= "<<ingredients<<"\nprice= "<<price<<"\ncalories= "<<calories;
	}

/* to print on to a stream.file or file*/
void printOn (ostream & o)
  {


    o << name<<'\n'<<ingredients<<'\n'<<price<<'\n'<<calories<<'\n';


  }
	/*operator != overloaded to check the equality of 2 node*/
  int operator != (LongDrink l)
  {

	if(strcmp(name,l.name)==0) {return 0;}
	else return 1;

  }
};
/*Soda class deriving from Food*/
class Soda :public Food
{
	public:
    
	Soda(){}
	Soda(char name1[], float cost, int cal) 
	{
		
		strcpy(name,name1);
		price=cost;
		calories=cal;
		
		
	}

	void print()
	{
		cout<<endl<<"\nname= "<<name<<"\nprice= "<<price<<"\ncalories= "<<calories;
	}


/* to print on to a stream.file or file*/
void printOn (ostream & o)
  {


    o << name<<'\n'<<price<<'\n'<<calories<<'\n';


  }
	/*operator != overloaded to check the equality of 2 node*/
  int operator != (Soda s)
  {

	if(strcmp(name,s.name)==0) {return 0;}
	else return 1;

  }
};
